#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>

typedef struct
{
    char Name[32];
    char Phone[40];
    char Logon[40];
    char Logon2[40];
    char Comment[40];
    char Modem[32];
    char Flags[16];
    char Protocol[16];
}
PHONE_ITEM;

#ifdef QDOS
char _prog_name[] = "qtprobe";
#endif

char *emus[] =
{"VT52", "VT100", "VT102", "ANSI1", "ANSI2", "ANSI3", "ANSI4", NULL};
static char *parity[] =
{"None", "Even", "Odd", "Space", "Mark", "CIS", NULL};
static char *bauds[] =
{"75", "300", "600", "1200", "2400", "4800", "9600", "19200", "None", NULL};
char *eols[] =
{"<LF>", "<CR>", "<CR/LF>", NULL};
char *sheiks[] =
{"Handshake", "Ignore", NULL};
char *yesno[] =
{"No", "Yes", NULL};
char *dels[] =
{"DEL(127)", "BS(8)", NULL};

static char *pCheck = "QeM v4";
#define VCHECKL      6

void zfill (char *nam, char *s, short n)
{
    short i;

    printf ("%s : %s\n", nam, s);
    for (i = strlen (s); i < n; i++)
    {
	*(s + i) = '\0';
    }
}

void FlagTest (PHONE_ITEM * pl, short val, char *nam, char **opt, short def, short act)
{
    short mv = pl->Flags[val];
    char **ol;
    short at, found;

    for (found = 0; !found;)
    {
	for (at = 0, ol = opt; *ol; ol++, at++)
	{
	    if (at == mv)
	    {
		found = 1;
		break;
	    }
	}
	if (found)
	{
	    printf ("Setting for %s is %s\n", nam, *ol);
	}
	else
	{
	    if (act == 0)
	    {
		printf ("Unexpected value %5d for %s, acceptable values are: \n", mv, nam);
		for (at = 0, ol = opt; *ol; ol++, at++)
		{
		    printf ("%d : %s\n", at, *ol);
		}
		fputs ("Please enter a new value ? ", stdout);
		scanf ("%hd", &mv);
		pl->Flags[val] = mv;
	    }
	    else if(act == 1)
	    {
		printf (">>>> Default for %s is %s\n", nam, *(opt+def));
		pl->Flags[val] = def;
		found = 1;
	    }
	    else
	    {
		printf ("**** Unexpected value %5d for %s \n", mv, nam);
		found = 1;
	    }
	}
    }
}


void verify (PHONE_ITEM * pl, short act)
{

    zfill ("Name", pl->Name, 32);
    zfill ("Phone", pl->Phone, 40);
    zfill ("Logon", pl->Logon, 40);
    zfill ("Logon2", pl->Logon2, 40);
    zfill ("Comment", pl->Comment, 40);
    zfill ("Modem", pl->Modem, 32);
    zfill ("Protocol", pl->Protocol, 16);

/*
   * Flag usage (for QTPI)
   * 0 - Emulation, 7 - RX EOL, 8 - TX EOL, 9 - DelC, 10 - Baud
   * 11 - parity, 12 - Shake, 13 - Keyflag
 */

    pl->Flags[14] = pl->Flags[15] = 0;
    FlagTest (pl, 0, "Emulation", emus,1, act);
    FlagTest (pl, 7, "RX-EOL", eols, 2, act);
    FlagTest (pl, 8, "TX-EOL", eols, 1, act);
    FlagTest (pl, 9, "DelC", dels, 1, act);
    FlagTest (pl, 10, "Baud", bauds, 7, act);
    FlagTest (pl, 11, "Parity", parity, 0, act);
    FlagTest (pl, 12, "H'Shake", sheiks, 0, act);
    FlagTest (pl, 13, "7 bit Keys", yesno, 0 ,act);
}

int main (int ac, char **av)
{
    PHONE_ITEM pl;
    int fd;
    char vCheck[VCHECKL];
    short act = 0;
    int c;
    char *fn;

    while((c = getopt(ac, av, "di")) != EOF)
    {
	switch(c)
	{
	    
        case 'd':
	    act = 1;
	    break;
        case 'i':
	    act = 2;
	    break;
	}
	
    }
    
    fn = *(av+optind++);
    
    if (fn && (fd = open (fn, O_RDONLY, 0)) > 0)
    {
	int ofd = 0;

	read (fd, vCheck, VCHECKL);
	if (strncmp (vCheck, pCheck, (size_t) VCHECKL) == 0)
	{
	    fn = *(av+optind);
	    if(fn && act != 2)
	    {
		ofd = open (fn, O_CREAT | O_WRONLY, 0);
	    }
	    if(ofd >= 0)
	    {
		
		if(ofd > 0)
		    write (ofd, vCheck, (size_t) VCHECKL);

		while (read (fd, &pl, sizeof (pl)) > 0)
		{
		    verify (&pl, act);
		    if(ofd > 0)
			write (ofd, &pl, sizeof (pl));
		}
	        if(ofd > 0)
		    close (ofd);
	    }
	    else
	    {
		perror ("output");
	    }
	}
	close (fd);
    }
    else
    {
	perror ("open file");
    }
    return 0;
}


